
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/sockios.h>
#include <linux/if_ether.h>
#include <linux/if_arp.h>
#include <linux/if_packet.h>
#include <sys/time.h>
#include <unistd.h>
//#include "../boa.h"
#include "scanport_packet.h"
#include "arpping.h"

typedef struct arp_packet
{
	u_char Dst_e_hw[ETH_ALEN];
	u_char Src_e_hw[ETH_ALEN];
	u_short frame_type;
	u_short hw_type;
	u_short prot_type;
	u_char hw_addr_size;
	u_char prot_addr_size;
	u_short op;
	u_char Src_a_hw[ETH_ALEN];
	u_char Src_a_ip[4];
	u_char Dst_a_hw[ETH_ALEN];
	u_char Dst_a_ip[4];
} __attribute__ ((packed)) ARP_PACKET;

void scanport_die(char *str);
void scanport_get_hw_addr(char *buf, char *str);

#ifdef ATTACHED_DEVICES
int scanport_SendArpPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw, u_char *op, u_char *src_a_hw, u_char *src_a_ip, u_char *dst_a_hw, u_char *dst_a_ip);
#else
int scanport_SendArpPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw, u_char *op, u_char *src_a_hw, u_char *src_a_ip, u_char *dst_a_hw, u_char *dst_a_ip,int cnt);
#endif
int scanport_getdevindex(int sock, u_char *name);
int scanport_strip(unsigned char *dst, unsigned char *str);
int arp_Reply;
//u_char hostname[34];


#ifdef  ATTACHED_DEVICES
unsigned char scan_dst_ip[4];
unsigned char scan_dst_hw[6];
int attached_devices(unsigned char *scan_ip, unsigned char *mac, unsigned char *hostname)
{
	int result = -1, retValue = 0, count = 0;
	unsigned char argv[8][20], str[30];
	unsigned char src_a_ip[20];
#if 1
	int i = 0, j = 0;
	unsigned char yiaddr[20]="";
	unsigned char lan_ipaddr[20]="";
	unsigned char lan_hwaddr[20];
	unsigned char _lan_hwaddr[20];
	unsigned char dev[5]="";
	unsigned char tmp[5], tmp1[6];//, *value;
	int value = 0;

#endif

	strcpy(argv[1], "eth1");
	strcpy(argv[7], mac);
	strcpy(argv[8], scan_ip);
	strcpy(src_a_ip, nvram_get("lan_ipaddr"));
	DPRINTF("src_a_ip = %s\n", src_a_ip);
	DPRINTF("mac = %s\n", mac);
#if 0	
	for (count = 0; count < 2; count++) {
      		retValue = scanport_SendArpPkt(argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
		if (retValue == 1)
			break;
	}
#endif	

#if 1
	memset(yiaddr, 0, 20);
	strncpy(yiaddr, scan_ip, strlen(scan_ip)); 
	DPRINTF("yiaddr = %s\n", yiaddr);
	strcpy(lan_ipaddr, nvram_get("lan_ipaddr"));
#if 0
	sscanf(nvram_get("lan_hwaddr"), "%x:%x:%x:%x:%x:%x", &lan_hwaddr[0], &lan_hwaddr[1], &lan_hwaddr[2], &lan_hwaddr[3], &lan_hwaddr[4], &lan_hwaddr[5]);
	printf("lan_hwaddr = %x:%x:%x:%x:%x:%x\n", lan_hwaddr[0], lan_hwaddr[1], lan_hwaddr[2], lan_hwaddr[3], lan_hwaddr[4], lan_hwaddr[5]);
	//strcpy(lanIP, lan_ipaddr);
#endif

	strcpy(lan_hwaddr, nvram_get("lan_hwaddr"));
	j = 0;
	for ( i = 0; i < strlen(lan_hwaddr); i++) {
		if ( (i  !=  2) && (i  !=  5) && (i  !=  8) && ( i  !=  11) && ( i  !=  14)) {
			_lan_hwaddr[j] = lan_hwaddr[i];
			DPRINTF("* _lan_hwaddr[%d] = %c\n", j,  _lan_hwaddr[j]);
			j++;
		}
	}

	j = 0;
	for ( i = 0; i < 12; i++) {
		value = 0;
		sprintf(tmp, "%c%c", _lan_hwaddr[i], _lan_hwaddr[i+1]);
		value = strtol(tmp, NULL, 16);
		tmp1[j++] = value;
		i++;
	}	

	strncpy(dev, "eth1", 4);
	count = 0;
	do {
		result = scanport_arpping(yiaddr, lan_ipaddr, tmp1, dev, mac);
	} while ((result == -1) && (++count <= 3));
	if (!result) {
	//if (!scanport_arpping(yiaddr, lan_ipaddr, tmp1, dev, mac)) {
		strcpy(hostname, "");
		result = netbios_packet(src_a_ip, NMB_PORT, yiaddr/*scan_ip*/, NMB_PORT, hostname);  
		//printf("result = %d\n", result);
		if( result == 1 && hostname[0] != NULL && strlen(hostname) != NULL ){
			printf("\n\nquery wins server response from %d.%d.%d.%d\n",scan_dst_ip[0], scan_dst_ip[1], scan_dst_ip[2], scan_dst_ip[3]);
			printf("destMac = ");
			printf("%02x %02x %02x %02x %02x %02x\n", scan_dst_hw[0], scan_dst_hw[1], scan_dst_hw[2], scan_dst_hw[3], scan_dst_hw[4], scan_dst_hw[5]);
			printf("hostname = %s\n\n\n", hostname);
			return 1;
		}
		else {
			printf("\n\nquery wins server response from %d.%d.%d.%d\n",scan_dst_ip[0], scan_dst_ip[1], scan_dst_ip[2], scan_dst_ip[3]);
			printf("destMac = ");
			printf("%02x %02x %02x %02x %02x %02x\n", scan_dst_hw[0], scan_dst_hw[1], scan_dst_hw[2], scan_dst_hw[3], scan_dst_hw[4], scan_dst_hw[5]);
			printf("hostname = %s\n\n\n", hostname);
			return 2;
		}	
	} else {
		//printf("no arp reply from %s\n", yiaddr);
		return 0;
	}
#endif

#if 0
	DPRINTF("arp reply = %02x\n", arp_Reply);
	if ( arp_Reply == 0x02 ) {
		arp_Reply = 0x00;
		result = netbios_packet(src_a_ip, NMB_PORT, scan_ip, NMB_PORT, hostname);  
		if( result == 0 ){
			printf("\n\nquery wins server response from %d.%d.%d.%d\n",scan_dst_ip[0], scan_dst_ip[1], scan_dst_ip[2], scan_dst_ip[3]);
			printf("destMac = ");
			printf("%02x %02x %02x %02x %02x %02x\n", scan_dst_hw[0], scan_dst_hw[1], scan_dst_hw[2], scan_dst_hw[3], scan_dst_hw[4], scan_dst_hw[5]);
			printf("hostname = %s\n", hostname);
			return 1;
		}
	} else {
		arp_Reply == 0x00;
		return -1;
	}
	printf("\n");
	
	return 1;
#endif
}	
#else
#ifdef	SCANPORT
void main(int argc, u_char *argv[])
{
	scan_nbis(argv[1]);
}
#endif

#ifdef	SCANPORT
void scan_nbis(u_char *dev)
#else
void scan_nbis()
#endif
{
	int cnt = 1;
	int result = -1;
	u_char scan_ip[10], argv[9][5], str[30];
	u_char *src_a_ip = "192.168.1.254";

	DPRINTF("%s\n", __FUNCTION__);
#ifdef	SCANPORT
	strcpy(argv[1], dev);
#else
	strcpy(argv[1], "eth1");
	src_a_ip = nvram_get("lan_ipaddr");
	DPRINTF("src_a_ip = %s\n", src_a_ip);
#endif

	memset(device_scand, 0, sizeof(device_scand));

	for (cnt = 1; cnt < 255; cnt++) {
		sprintf(scan_ip, "192.168.1.%d", cnt);
		strcpy(argv[8], scan_ip);
      		scanport_SendArpPkt(argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], cnt);
		DPRINTF("arp reply = %02x\n", arp_Reply);
		if ( arp_Reply == 0x02 ) {
			DPRINTF("arp reply received from %d.%d.%d.%d\n",device_scand[cnt].scan_dst_ip[0],device_scand[cnt].scan_dst_ip[1], device_scand[cnt].scan_dst_ip[2], device_scand[cnt].scan_dst_ip[3]);
			DPRINTF("destMac = ");
			DPRINTF("%02x %02x %02x %02x %02x %02x\n", device_scand[cnt].scan_dst_hw[0], device_scand[cnt].scan_dst_hw[1], device_scand[cnt].scan_dst_hw[2], device_scand[cnt].scan_dst_hw[3], device_scand[cnt].scan_dst_hw[4], device_scand[cnt].scan_dst_hw[5]);
			if ( device_scand[cnt].scan_dst_hw[3] == 0x00 && device_scand[cnt].scan_dst_hw[4] == 0x00 && device_scand[cnt].scan_dst_hw[5] == 0x00 )
				DPRINTF("unavilable mac address\n");
			else {		    	
				//sprintf(str, "nmblookup -Ar %d.%d.%d.%d", device_scand[cnt].scan_dst_ip[0],device_scand[cnt].scan_dst_ip[1], device_scand[cnt].scan_dst_ip[2], device_scand[cnt].scan_dst_ip[3]);
				//printf("%s\n", str);
				//system(str);
				//execle("/usr/bin/nmblookup", "-Ar", "10.0.0.140", ">> 140");
				//system(str > 1234);
				//system(ls);
				//result = send_query_wins_server(cnt);
				sprintf(scan_ip, "%d.%d.%d.%d", device_scand[cnt].scan_dst_ip[0],device_scand[cnt].scan_dst_ip[1], device_scand[cnt].scan_dst_ip[2], device_scand[cnt].scan_dst_ip[3]);
				result = netbios_packet(src_a_ip, NMB_PORT, scan_ip, NMB_PORT, cnt);  
				if( result == 0 ){
					printf("\n\nquery wins server response from %d.%d.%d.%d\n",device_scand[cnt].scan_dst_ip[0],device_scand[cnt].scan_dst_ip[1], device_scand[cnt].scan_dst_ip[2], device_scand[cnt].scan_dst_ip[3]);
					printf("destMac = ");
					printf("%02x %02x %02x %02x %02x %02x\n", device_scand[cnt].scan_dst_hw[0], device_scand[cnt].scan_dst_hw[1], device_scand[cnt].scan_dst_hw[2], device_scand[cnt].scan_dst_hw[3], device_scand[cnt].scan_dst_hw[4], device_scand[cnt].scan_dst_hw[5]);
					printf("hostname = %s\n", device_scand[cnt].hostname);
				}
			}
		} else
			arp_Reply == 0x00;
		printf("\n");
	}
}	
#endif

#if 0
/*struct response_record *queue_query_name_from_wins_server( struct in_addr to_ip,
                          response_function resp_fn,
                          timeout_response_function timeout_fn,
                          query_name_success_function success_fn,
                          query_name_fail_function fail_fn,
                          struct userdata_struct *userdata,
                          struct nmb_name *nmbname)*/
                         
int send_query_wins_server(int cnt)                     
{
  struct in_addr to_ip;
  struct nmb_name *nmbname;
  struct packet_struct *p;
  u_char scan_ip[4];
  u_char mac[6];
  u_char *src_a_ip = "192.168.1.254";
  int i, result;
  //struct response_record *rrec;

  //inet_aton("192.168.1.1", &to_ip.s_addr);
  //printf("to_ip = %s\n", &to_ip.s_addr);
  //if ((p = create_and_init_netbios_packet(nmbname, False, False, to_ip)) == NULL)
    //return NULL;
  sprintf(scan_ip, "%d.%d.%d.%d", device_scand[cnt].scan_dst_ip[0],device_scand[cnt].scan_dst_ip[1], device_scand[cnt].scan_dst_ip[2], device_scand[cnt].scan_dst_ip[3]);
  printf("%s = dest_ip = %s\n", __FUNCTION__, scan_ip);
  		
  result = netbios_packet(src_a_ip, NMB_PORT, scan_ip, NMB_PORT, cnt);  
  	
  /*if(initiate_name_query_packet_from_wins_server(src_a_ip, scan_ip, mac) == False)
  {
    //p->locked = False;
    //free_packet(p);
    return NULL;
  }*/

  return result;
}
#endif

void scanport_die(char *str)
{
	FPRINTF(stderr, "\nAttention exit for the followent reason : %s\n", str);
	exit(0);
}

int scanport_getdevindex(int sock, u_char *name)
{
	struct ifreq ifr;

	memset(&ifr, 0, sizeof(ifr));
	strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));

	if(ioctl(sock, SIOCGIFINDEX, &ifr) == -1) 
		scanport_die("I can't get device flags...");
	FPRINTF(stderr, "Get ethernet flags...\n");
	DPRINTF("%s = %d\n", __FUNCTION__, ifr.ifr_ifindex);
	
	return ifr.ifr_ifindex;
}

void scanport_get_hw_addr(char *buf, char *str)
{
	int i;
	char c, val;

	for (i=0; i < ETH_ALEN; i++) {
		if (!(c=tolower(*str++))) scanport_die("Invalid hardware address");
		if (isdigit(c)) val=c-'0';
		else if (c >= 'a' && c <= 'f') val = c-'a'+10;
		else scanport_die("Invalid hardware address");
		*buf = val << 4;
		if (!(c=tolower(*str++))) scanport_die("Invalid hardware address");
		if (isdigit(c)) val=c-'0';
		else if (c >= 'a' && c <= 'f') val = c-'a'+10;
		else scanport_die("Invalid hardware address");
		*buf++ |= val;
		if (*str == ':') str++;
	}
}

int scanport_strip(unsigned char *dst, unsigned char *str)
{
	if (sscanf(str, "%d.%d.%d.%d", &dst[0], &dst[1], &dst[2], &dst[3]) == 4)
		return 0;
	return -1; 
			
}

int scanport_arpping(unsigned char *yiaddr, unsigned char *lan_ip, unsigned char *lan_mac, unsigned char *dev,unsigned char *Target_mac)
{

	int	timeout = 1;
	int 	optval = 1;
	int	s;			/* socket */
	int	rv = 1;			/* return value */
	struct sockaddr addr;		/* for interface name */
	struct arpMsg	arp;
	fd_set		fdset;
	struct timeval	tm;
	time_t		prevTime;
	int i = 0, ret, count;
	unsigned char targetIP[4], arpReplyMac[20];
	
	DPRINTF("yiaddr = %s; lan_ip = %s; dev = %s; Target_mac = %s\n", yiaddr, lan_ip, dev, Target_mac);
	DPRINTF("%02x %02x %02x %02x %02x %02x\n", lan_mac[0], lan_mac[1], lan_mac[2], lan_mac[3], lan_mac[4], lan_mac[5]);
	
	if ((s = socket (PF_PACKET, SOCK_PACKET, htons(ETH_P_ARP))) == -1) {
		printf( "Could not open raw socket\n");
		return -1;
	}
	
	if (setsockopt(s, SOL_SOCKET, SO_BROADCAST, &optval, sizeof(optval)) == -1) {
//		cprintf(LOG_ERR, "Could not setsocketopt on raw socket");
		printf( "Could not setsocketopt on raw socket\n");
		close(s);
		return -1;
	}

	/* send arp request */
	memset(&arp, 0, sizeof(arp));
	memcpy(arp.ethhdr.h_dest, MAC_BCAST_ADDR, 6);	/* MAC DA */
	memcpy(arp.ethhdr.h_source, lan_mac, 6);		/* MAC SA */
	arp.ethhdr.h_proto = htons(ETH_P_ARP);		/* protocol type (Ethernet) */
	arp.htype = htons(ARPHRD_ETHER);		/* hardware type */
	arp.ptype = htons(ETH_P_IP);			/* protocol type (ARP message) */
	arp.hlen = 6;					/* hardware address length */
	arp.plen = 4;					/* protocol address length */
	arp.operation = htons(ARPOP_REQUEST);		/* ARP op code */
	inet_aton(lan_ip, arp.sInaddr);
	inet_aton(yiaddr, arp.tInaddr);
	//*((u_int *) arp.sInaddr) = ip;			/* source IP address */
	memcpy(arp.sHaddr, lan_mac, 6);			/* source hardware address */
	//*((u_int *) arp.tInaddr) = yiaddr;		/* target IP address */
	
	memset(&addr, 0, sizeof(addr));
	strncpy(addr.sa_data, dev, 4);
	if (sendto(s, &arp, sizeof(arp), 0, &addr, sizeof(addr)) < 0) {
		rv = 0;
		printf("%s: sendto error!\n", __FUNCTION__);
	}
	
#ifdef  SCANPORT_DEBUG
	DPRINTF("sending arp reply ... \n");
	for (i = 0; i < sizeof(arp); i++) {
		unsigned char *ptr;

		ptr = (unsigned char *)&arp;
		DPRINTF("%02x ", ptr[i]);
	}
#endif

	/* wait arp reply, and check it */
	//tm.tv_usec = 0;
	tm.tv_sec = 0;
	time(&prevTime);
	
	count = 0;
	while (timeout > 0 || count < 2) {  
		count++;
		FD_ZERO(&fdset);
		FD_SET(s, &fdset);
		//tm.tv_sec = timeout;
		tm.tv_usec = 500000;	/* 500ms */

		ret = select(s + 1, &fdset, (fd_set *) NULL, (fd_set *) NULL, &tm);
		printf("%s select ret = %d\n", __FUNCTION__, ret);
		if (ret == -1) {
			//fprintf(LOG_ERR, "Error on ARPING request: %s", strerror(errno));
			//if (errno != EINTR) rv = 0;
			printf("%s: Error on ARPING request erron=%d\n", __FUNCTION__, errno);
			//goto check_timeout;
			if (errno != EINTR) rv = 0;
			goto exit_select;

		} else if (ret == 0) {
			printf("%s: Timeout on ARPING request\n", __FUNCTION__);
			goto check_timeout;
		} else if (FD_ISSET(s, &fdset)) {
			if (recv(s, &arp, sizeof(arp), 0) < 0 ) {
				rv = 0;
				printf("%s: recv error !\n", __FUNCTION__);
				goto check_timeout;
			}
			
#ifdef  SCANPORT_DEBUG
			
			DPRINTF("received arp reply ..\n");
			for (i = 0; i < sizeof(arp); i++) {
				unsigned char *ptr;

				ptr = (unsigned char *)&arp;
				DPRINTF("%02x ", ptr[i]);
			}

			DPRINTF("lan_mac %02x %02x %02x %02x %02x %02x\n", lan_mac[0], lan_mac[1], lan_mac[2], lan_mac[3], lan_mac[4], lan_mac[5]);
			DPRINTF("arp.tHaddr %02x %02x %02x %02x %02x %02x\n", arp.tHaddr[0], arp.tHaddr[1], arp.tHaddr[2], arp.tHaddr[3], arp.tHaddr[4], arp.tHaddr[5]);
			DPRINTF("arp.operation %02x\n", arp.operation);
			DPRINTF("arp.sInaddr %d %d %d %d\n", arp.sInaddr[0], arp.sInaddr[1], arp.sInaddr[2], arp.sInaddr[3]);
			DPRINTF("devIP %d %d %d %d\n", targetIP[0], targetIP[1], targetIP[2], targetIP[3]);
#endif

			inet_aton(yiaddr, targetIP);
			if (arp.operation == htons(ARPOP_REPLY) && memcmp(arp.tHaddr, lan_mac, 6) == 0 &&  memcmp(arp.sInaddr, targetIP, 4) == 0) {
				//fprintf(LOG_INFO, "Valid arp reply receved for this address");
				memcpy(scan_dst_hw, arp.sHaddr, ETH_ALEN);
				memcpy(scan_dst_ip, arp.sInaddr, 4);
				DPRINTF("Valid arp reply receved for this address\n");
				rv = 0;
				break;
			}
		}
check_timeout:
		timeout -= time(NULL) - prevTime;
		time(&prevTime);
	}
exit_select:
	close(s);
	if (rv==0){
		if ((ret != -1) && (Target_mac != NULL)){
			sprintf(arpReplyMac, "%02x:%02x:%02x:%02x:%02x:%02x", arp.sHaddr[0], arp.sHaddr[1], arp.sHaddr[2], arp.sHaddr[3], arp.sHaddr[4], arp.sHaddr[5]);
			
			for ( i = 0; i < strlen(arpReplyMac); i++ ) 
				arpReplyMac[i] = toupper(arpReplyMac[i]);
			
			DPRINTF("arpReplyMac = %s\n", arpReplyMac);
			//if(memcmp(arp.sHaddr,Target_mac,6)){
			if(strncmp(arpReplyMac,Target_mac,strlen(arpReplyMac))){	
				DPRINTF("************************\n");
				rv=1;
			}
		} else
			rv=1;
	}
	DPRINTF("rv = %d\n", rv);
//	cprintf(LOG_INFO, "%salid arp replies for this address", rv ? "No v" : "V");
	printf("%salid arp replies for this address %s\n\n", rv ? "No v" : "V", yiaddr);
	if ((ret == -1) && ( rv == 1)) return -1;
	return rv;
}


#ifdef ATTACHED_DEVICES
int scanport_SendArpPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw, u_char *op, u_char *src_a_hw, u_char *src_a_ip, u_char *dst_a_hw, u_char *dst_a_ip)
#else
int scanport_SendArpPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw, u_char *op, u_char *src_a_hw, u_char *src_a_ip, u_char *dst_a_hw, u_char *dst_a_ip,int cnt)
#endif
{
	struct sockaddr_ll to;
	struct sockaddr_ll sock_fd;
	ARP_PACKET pkt;
	int sock;
	struct ifreq ifr;
	int i, bytes;
	struct timeval tm; 
	int timeout = 2;
	time_t		prevTime;
	//struct hostent *host;
	//int fd;

	if ((sock = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		scanport_die("Can't create socket...");
	
	memset(&ifr, 0, sizeof(ifr));
	ifr.ifr_addr.sa_family = AF_INET;
	//strcpy(dev, "eth0");
	if (ioctl(sock, SIOCGIFINDEX, &ifr) == 0) 
		DPRINTF("ifr.ifr_ifindex = %d\n", ifr.ifr_ifindex);
		
	//ifr.ifr_ifindex = 2;
	if (ioctl(sock, SIOCGIFNAME, &ifr) == 0)
		DPRINTF("ifr.ifr_name = %s\n", ifr.ifr_name);
	
	close(sock);
	
	if ((sock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) == -1)
		scanport_die("Can't create socket");
	
	
	if ((to.sll_ifindex = scanport_getdevindex(sock, dev)) == -1) {
		close(sock);
		scanport_die("Can't get interface");
	}
	 //{
	  //struct ifreq ifr;

	  memset(&ifr, 0, sizeof(ifr));
	  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
	  ifr.ifr_ifindex = to.sll_ifindex;

	  if(ioctl(sock, SIOCGIFHWADDR, &ifr) == -1) 
	    	scanport_die("I can't get device hw addr...");
	  
	  memcpy(sock_fd.sll_addr, ifr.ifr_hwaddr.sa_data, ETH_ALEN);
		
		
	  /* please trying arpping() in dniutil/shutils.c 
	     instead of below codes */	
	//}
	
	/* Eth header */
	//scanport_get_hw_addr(pkt.Src_e_hw, src_e_hw);
	memcpy(pkt.Src_e_hw, sock_fd.sll_addr, ETH_ALEN);
	//scanport_get_hw_addr(pkt.Dst_e_hw, dst_e_hw);
#define DST_MAC_ADDR 	((unsigned char *)("\xff\xff\xff\xff\xff\xff"))	
	memcpy(pkt.Dst_e_hw, DST_MAC_ADDR, ETH_ALEN);
	pkt.frame_type = htons(ETH_P_ARP);
	FPRINTF(stderr, "Eth header is ready...\n");
	
	/* arp */
#define ARPHDR_ETHER		0x01
	pkt.hw_type = htons(ARPHDR_ETHER);
	pkt.prot_type = htons(ETH_P_IP);
	pkt.hw_addr_size = ETH_ALEN;
	pkt.prot_addr_size = 4;
	//pkt.op = htons(op);
	pkt.op = htons(0x01);
	FPRINTF(stderr, "Arp header is ready...\n");
	/* data */
	//scanport_get_hw_addr(pkt.Src_a_hw, src_a_hw);
	//scanport_get_hw_addr(pkt.Dst_a_hw, dst_a_hw);
	//if (*src_a_ip == NULL)
		//src_a_ip = "192.168.1.254";
	//if(*dst_a_ip == NULL)
		//dst_a_ip = "10.0.0.138";
	
	//scanport_strip(pkt.Src_a_ip, src_a_ip);
	//scanport_strip(pkt.Dst_a_ip, dst_a_ip);
#ifdef  ATTACHED_DEVICES
	strcpy(src_a_ip, nvram_get("lan_ipaddr"));
	//printf("src_a_ip = %s\n", src_a_ip);

#else
	strcpy(src_a_ip, "192.168.1.1"));
#endif
	inet_aton(src_a_ip, pkt.Src_a_ip);
	inet_aton(dst_a_ip, pkt.Dst_a_ip);
	DPRINTF("src_a_ip = %d.%d.%d.%d\n", pkt.Src_a_ip[0], pkt.Src_a_ip[1], pkt.Src_a_ip[2], pkt.Src_a_ip[3]);
	DPRINTF("dst_a_ip = %d.%d.%d.%d\n", pkt.Dst_a_ip[0], pkt.Dst_a_ip[1],pkt.Dst_a_ip[2],pkt.Dst_a_ip[3]);
	//scanport_get_hw_addr(pkt.Src_a_hw, src_a_hw);
	memcpy(pkt.Src_a_hw, pkt.Src_e_hw, ETH_ALEN);
	//scanport_get_hw_addr(pkt.Dst_a_hw, dst_a_hw);
	memcpy(pkt.Dst_a_hw, DST_MAC_ADDR, ETH_ALEN);
	/* write and send */
	/*for (i = 0; i < sizeof(pkt); i++) {
		unsigned char *ptr;

		ptr = (unsigned char *)&pkt;
		DPRINTF("%02x ", ptr[i]);
	}*/
	DPRINTF("\n");
	if (sendto(sock, &pkt, sizeof(pkt), 0, (struct sockaddr *)&to, sizeof(to)) < 0) {
		close(sock);
		scanport_die("I can't send pkt");
	}
	FPRINTF(stderr, "The ARP packet is send. The matrix is around you!\n");
	//close(sock);


	fd_set in;
	int ret;
	/* wait arp reply, and check it */
	tm.tv_sec = timeout;		/* wait 2 sec */
	tm.tv_usec = 0;
	time(&prevTime);
	while (timeout > 0) {

	FD_ZERO(&in);
	FD_SET(sock, &in);
	
	ret = select(sock+1, &in, NULL, NULL, &tm);
	
	if (ret > 0) {
		if(!(FD_ISSET(sock, &in))) {
			close(sock);
			return -1;
		}

		memset(&pkt, 0, sizeof(pkt));
	      	
	      	bytes = read(sock, &pkt, sizeof(pkt));
		DPRINTF("bytes = %d\n", bytes);

		if (bytes <0) {
			close(sock);
			return -1;
		}
		
		u_char *ptr;
		ptr = (unsigned char *)&pkt;
		DPRINTF("arp reply : %02x\n", ptr[21]);
		arp_Reply = ptr[21];
		for (i = 0; i < bytes; i++) {
		      		DPRINTF("%02x ", ptr[i]);
		}
	      	if ((bytes > 0) && (memcmp(pkt.Dst_a_hw, &ptr[0], ETH_ALEN) == 0) && (ptr[21] == 0x02)) {
		  //if (/*1*/bytes) {
		    
		    //DPRINTF("arp reply : %02x\n", ptr[22]);
#ifdef ATTACHED_DEVICES
			memcpy(scan_dst_hw, &ptr[6], ETH_ALEN);
			memcpy(scan_dst_ip, &ptr[28], 4);
#else
		    	memcpy(device_scand[cnt].scan_dst_hw,  &ptr[6], ETH_ALEN);
		    	memcpy(device_scand[cnt].scan_dst_ip, &ptr[28], 4);
#endif
		   	/*for (i = 0; i < bytes; i++) {
		      		DPRINTF("%02x ", ptr[i]);
		    	}*/
		    	DPRINTF("\n");
		    	close(sock);
		    	return 1;
	        }
		
		DPRINTF("\n");
	}
	timeout -= time(NULL) - prevTime;
	time(&prevTime);
	}
	close(sock);
	
	//return 1;
	          
}

