/* dhcpd.c
 *
 * udhcp DHCP client
 *
 * Russ Dill <Russ.Dill@asu.edu> July 2001
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/file.h>
#include <unistd.h>
#include <getopt.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <time.h>
#include <string.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <errno.h>

#include "dhcpd.h"
#include "dhcpc.h"
#include "options.h"
#include "clientpacket.h"
#include "packet.h"
//#include "script.h"
#include "socket.h"
#include "debug.h"
//#include "pidfile.h"

// brcm
//#include "board_api.h"

//static int state;
//static unsigned long requested_ip; /* = 0 */
//static unsigned long server_addr;
//static unsigned long timeout;
//static int packet_num; /* = 0 */

/* Exit and cleanup */
static void exit_client(int retval)
{
	//pidfile_delete(client_config.pidfile);
	CLOSE_LOG();
	//exit(retval);
	return;
}

int Sendpptppacket(u_char *dev)
{
	//char *temp, *message;
	//unsigned long t1 = 0, t2 = 0, xid = 0;
	//fd_set rfds;
	int fd, result = 0;//, retval;
	//struct timeval tv;
	struct ifreq ifr;
	//struct in_addr temp_addr;
	//int pid_fd;
	
	if ((fd = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) >= 0) {
		//strcpy(ifr.ifr_name, "eth0");
		strcpy(ifr.ifr_name, dev);
		if (ioctl(fd, SIOCGIFINDEX, &ifr) == 0) {
			//DEBUG(LOG_INFO, "adapter index %d", ifr.ifr_ifindex);
			DPRINTF("adapter index %d", ifr.ifr_ifindex);

			client_config.ifindex = ifr.ifr_ifindex;
		} else {
			LOG(LOG_ERR, "SIOCGIFINDEX failed! %s", strerror(errno));
			//exit_client(1);
			return -1;
		}
		if (ioctl(fd, SIOCGIFHWADDR, &ifr) == 0) {
			memcpy(client_config.arp, ifr.ifr_hwaddr.sa_data, 6);
			//DEBUG(LOG_INFO, "adapter hardware address %02x:%02x:%02x:%02x:%02x:%02x",
				//client_config.arp[0], client_config.arp[1], client_config.arp[2], 
				//client_config.arp[3], client_config.arp[4], client_config.arp[5]);
			DPRINTF(LOG_INFO, "adapter hardware address %02x:%02x:%02x:%02x:%02x:%02x",
				client_config.arp[0], client_config.arp[1], client_config.arp[2], 
				client_config.arp[3], client_config.arp[4], client_config.arp[5]);
			memcpy(arp_sr_mac, client_config.arp, 6);
		} else {
			LOG(LOG_ERR, "SIOCGIFHWADDR failed! %s", strerror(errno));
			//exit_client(1);
			return -1;
		}
	} else {
		LOG(LOG_ERR, "socket failed! %s", strerror(errno));
		//exit_client(1);
		return -1;
	}
	close(fd);
	fd = -1;

	result = ttpt_packet();
	
	return result;
}
