#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <rc.h>
#include <dni_shutils.h>
#include <dni_nvram.h>

#define FW_UPDATE_URL_125G ""
#define FW_UPDATE_URL_54G ""


int main( int argc, char **argv)
{
#define FIRST_FW_CHK_PERIOD	600
#if 0
#define MAX_RETRY_TIMES	3
#define MAX_DELAY_COUNT	3
#endif

	static unsigned long time_secs_cumulate=0;
	//char *wan_proto;
	//int ret;
	char *pWan_proto, *pWan_ifname;
	int frmware_Chk_Period=FIRST_FW_CHK_PERIOD;  //first time ==> 1 mins
#if 0
	int do_it_later = MAX_DELAY_COUNT;
#endif

	signal(SIGCHLD, SIG_IGN);  //to prevent zombies process
#if 0
	signal(SIGUSR1, on_signal_MonTask);  //means recved a trigger event to check new firmware
#endif

	while(1)
	{

		sleep(5);
		//cprintf("%s::Enter\n", __FUNCTION__);
		time_secs_cumulate += 5;

		//every 10 mins  ==>dump firewall log
		if( time_secs_cumulate % 600 == 0  )  
		{
#if 0
			//FirewallLog();
			sys_logdump();
#endif
		}

		//every 1 min ==> check if any necessary task is dead
		if( (time_secs_cumulate % 60) == 0 )
		{
#if 0
			//check httpd task
			if( !task_is_running("httpd") )
			{
				cprintf("%s::httpd task is dead, going to restart it\n", __FUNCTION__);
				stop_httpd();
				start_httpd();
			}
#endif

			if( nvram_match("router_disable", "0") )
			{
				//check dhcpd task
				if( !task_is_running("udhcpd") )
				{
					cprintf("%s::dhcpd task is dead, going to restart it\n", __FUNCTION__);
					stop_dhcpd();
					start_dhcpd();
				}
	
				//check dnsmasq task
				if( !task_is_running("dnsmasq") )
				{
					cprintf("%s::dnsmasq task is dead, going to restart it\n", __FUNCTION__);
					//stop_dns();
					//start_dns();
					start_dns(0);  //don't reset resolv.conf
				}

//Note by dvd.chen, when wan_stop, the parental task will be killed, it is normal,
//so, make sure wan_if has ip to start it, otherwise just do nothing
				//check parental task
#ifdef	CONFIGURE_PARENTAL	
				pWan_proto = nvram_get("wan_proto");
				switch (*pWan_proto)
				{
					case 's':  //static
					case 'd':  //dhcp
					case 'h':  //heartbeat
						pWan_ifname = nvram_get("wan0_ifname");
						break;
					case 'p':  //pppoe OR pptp
						pWan_ifname = "ppp0";
						break;
					default:
						pWan_ifname = nvram_get("wan0_ifname");
						break;
				}
				if( CheckWanIfIPAddr(pWan_ifname) && (task_is_running("parental") != 1) )
				//if( task_is_running("parental") != 1 )
				{
					cprintf("%s::parental task is dead, going to restart it\n", __FUNCTION__);
					stop_parental_control();
					start_parental_control();					
				}
#endif	// #ifdef	CONFIGURE_PARENTAL

			//CheckWan is doing the same thing, so mark off here, by dvd.chen
			/*
				//check WAN task
				wan_proto=nvram_safe_get("wan_proto");
				if(!strcmp(wan_proto, "dhcp"))
				{
					//check dhcpc task
					ret = task_is_running("udhcpc0");
					//if( ret != 1 )
					if( ret == 0)
					{
						cprintf("%s::dhcpc task is dead, going to restart it\n", __FUNCTION__);
						//stop_wan();
						//start_wan();
						wan_restart();
					}
				}
				else if(!strcmp(wan_proto, "pppoe"))
				{	
					//check pppoecd task
					if( !task_is_running("ppp0") )
					{
						cprintf("%s::pppoecd task is dead, going to restart it\n", __FUNCTION__);
						//stop_wan();
						//start_wan();
						wan_restart();
					}
				}
				else if(!strcmp(wan_proto, "pptp"))
				{
					//check pptp task
					if( !task_is_running("ppp0") )
					{
						cprintf("%s::pptp task is dead, going to restart it\n", __FUNCTION__);
						//stop_wan();
						//start_wan();
						wan_restart();
					}
				}
				else if(!strcmp(wan_proto, "heartbeat"))
				{	
					//check dhcpc task, cause bpalogin start from dhcpc=>bound
					ret = task_is_running("udhcpc0");
					if( ret==0 )
					{
						cprintf("%s::heartbeat:dhcpc task is dead, going to restart it\n", __FUNCTION__);
						//stop_wan();
						//start_wan();
						wan_restart();
					}
					else if( ret==1 )
					{
						//check bpalogin task
						if( !task_is_running("bpalogin") )
						{
							cprintf("%s::heartbeat:bpalogin task is dead, going to restart it\n", __FUNCTION__);
							//stop_wan();
							//start_wan();
							wan_restart();
						}
					}
				}
			*/
			}
		}

		//check if new firmware available
#if 0
		if( (atoi(nvram_get("fw_auto_detect"))==1) && nvram_match("router_disable", "0")
			&&
			( (time_secs_cumulate % frmware_Chk_Period == 0) || g_trigger_to_get_fw ) )
#else
		if( (atoi(nvram_get("fw_auto_detect"))==1) && nvram_match("router_disable", "0")
			&& (time_secs_cumulate % frmware_Chk_Period == 0) )
#endif
		{
			char newVer[15];
			char *pFW_url;
			
			//cprintf("%s::time[%ld], checking new firmware from web site\n", 
			//	__FUNCTION__, time_secs_cumulate);
			newVer[0]=0;
			if( !strcmp(PRODUCT_WIRELESS_TYPE,"125g") ) 
				pFW_url = FW_UPDATE_URL_125G;
			else
				pFW_url = FW_UPDATE_URL_54G;
#if 0			
			if( g_trigger_to_get_fw && (do_it_later > 0) )
			{
				cprintf("%s::just recved trigger sig, do it next[%d] time\n", __FUNCTION__, do_it_later);
				do_it_later--;
				continue;
			}
#endif

			//check if WAN Interface has IP, otherwise, skip to next time
			pWan_proto = nvram_get("wan_proto");
			switch (*pWan_proto)
			{
				case 's':  //static
				case 'd':  //dhcp
				case 'h':  //heartbeat
					pWan_ifname = nvram_get("wan0_ifname");
					break;
				case 'p':  //pppoe OR pptp
					pWan_ifname = "ppp0";
					break;
				default:
					pWan_ifname = nvram_get("wan0_ifname");
					break;
			}
			if( !CheckWanIfIPAddr(pWan_ifname)  )
			{
				cprintf("%s::WAN Interface has no IP, skip checking FW to next time\n", __FUNCTION__);
				continue;
			}

			//Now, let's try to check new FW version,
			//because it could be failed to access the server, let's try 3 times once filed
#if 0
			if( GetFrmVer(pFW_url, newVer) )  //succeed to get firmware version from web site
#else
			if (0)
#endif
			{

				if( strcmp(newVer, nvram_get("os_version")) > 0 )  //web site version is newer than current one
				{
					//new_firmware_available = 1;
					if( nvram_invmatch( "new_fw_avail", "1") )
					{
						nvram_set("new_fw_avail", "1");
						nvram_commit();
						//cprintf("%s::new_fw_avail had been set to 1\n", __FUNCTION__);
					}
					cprintf("%s::new firmware available\n", __FUNCTION__);
				}
				else
				{
					//new_firmware_available = 0;
					if( nvram_invmatch("new_fw_avail", "0") )
					{
						
						nvram_set("new_fw_avail", "0");
						nvram_commit();
						//cprintf("%s::new_fw_availhad been set to 0\n", __FUNCTION__);
					}
					cprintf("%s::NO new firmware available\n", __FUNCTION__);
				}

				frmware_Chk_Period = 86400;  //every 1 day

			}
			else  //failed to get firmware version from web site 
			{
#if 0
				if( ++g_retry_times < MAX_RETRY_TIMES)
				{
					cprintf("%s::failed [%d] times to get firmware version from web site, left [%d] times to try\n", 
						__FUNCTION__, g_retry_times, (MAX_RETRY_TIMES-g_retry_times) );
					goto DO_IT_NEXT_TIME;			
				}

				cprintf("%s::failed [%d] times to get firmware version from web site, left [%d] times to try\n", 
						__FUNCTION__, g_retry_times, (MAX_RETRY_TIMES-g_retry_times) );

				//let the first_time frmware_Chk_Period have a chance to do new_FW_Chk if this time failed.
				if( time_secs_cumulate >= FIRST_FW_CHK_PERIOD )
				{
#endif
					cprintf("%s::sttting frmware_Chk_Period to 1 HR\n", __FUNCTION__);
					frmware_Chk_Period = 3600;  //every 1 hour
#if 0
				}
#endif
			}

#if 0
			if( do_it_later != MAX_DELAY_COUNT )
				do_it_later = MAX_DELAY_COUNT;

			if( g_retry_times > 0 )
				g_retry_times = 0;

			if( g_trigger_to_get_fw )
				g_trigger_to_get_fw = 0;

			//cprintf("%s::frmware_Chk_Period[%d], g_trigger_to_get_fw[%ld], g_retry_times[%d], do_it_later[%d]\n", 
			//	__FUNCTION__, frmware_Chk_Period, g_trigger_to_get_fw, g_retry_times, do_it_later);
#endif

		}
	}	

	return 0;
}
